BillwerkRestClient::BillwerkRestConnection Class Reference

class for Billwerk.com REST connections; returns BillwerkRestClient::BillwerkRestClient objects More...

Inheritance diagram for BillwerkRestClient::BillwerkRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the BillwerkRestConnection object More...
hash< auto > | getConstructorOptions (hash< auto > options)
| gets options for the constructor
string | getType ()
| returns `"billwerkrest"`

## Public Attributes

const | ConnectionScheme = ...
| Connection entry info.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
BillwerkRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a BillwerkRestClient::BillwerkRestClient object More...

## Detailed Description

class for Billwerk.com REST connections; returns BillwerkRestClient::BillwerkRestClient objects

supports the following options:

- `"client_id"` (optional): the billwerk.com client_id
- `"client_secret"` (mandatory): the billwerk.com client_secret
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"data"`: see RestClient::RestClient::DataSerializationOptions for possible values when used with the null REST schema validator; the default is `"auto"`
- `"error_passthru"`: if True then HTTP status codes indicating errors will not cause an `HTTP-CLIENT-RECEIVE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"swagger"`: the path to a Swagger 2.0 REST schema file for runtime API validation (see the Swagger module)
- `"timeout"`: transfer timeout to use in milliseconds

Note
  additionally supports the following runtime option in getImpl():
  - `"validator"`: an AbstractRestSchemaValidator object for REST message validation (if present, overrides any REST schema validation option provided as a connection option)

See also
  BillwerkRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor()

BillwerkRestClient::BillwerkRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the BillwerkRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getImpl()

BillwerkRestClient BillwerkRestClient::BillwerkRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a BillwerkRestClient::BillwerkRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a BillwerkRestClient object